;;; DO NOT MODIFY THIS FILE
(if (featurep 'cedet-common-autoloads) (error "Already loaded"))

;;;### (autoloads nil "_pkg" "cedet-common/_pkg.el")

(package-provide 'cedet-common :version 1.01 :author-version "1.0pre4" :type 'regular)

;;;***

;;;### (autoloads (cedet-update-autoloads) "cedet-autogen" "cedet-common/cedet-autogen.el")

(autoload 'cedet-update-autoloads "cedet-autogen" "\
Update autoloads in file LOADDEFS from sources.
Optional argument DIRECTORY, specifies the directory to scan for
autoloads.  It defaults to the current directory.
DIRECTORIES is a list of extra directory to scan.  Those directory
names are relative to DIRECTORY.  If DIRECTORIES is nil try to scan
sub directories of DIRECTORY where a `cedet-autogen-tagfile' file
exists." t nil)

;;;***

;;;### (autoloads nil "cedet-compat" "cedet-common/cedet-compat.el")

;;;***

;;;### (autoloads nil "cedet-edebug" "cedet-common/cedet-edebug.el")

(add-hook 'edebug-setup-hook (lambda nil (require 'cedet-edebug) (defalias 'edebug-prin1-to-string 'cedet-edebug-prin1-to-string) (define-key edebug-mode-map "A" 'semantic-adebug-edebug-expr)))

(add-hook 'debugger-mode-hook (lambda nil (require 'cedet-edebug) (define-key debugger-mode-map "A" 'semantic-adebug-edebug-expr)))

;;;***

;;;### (autoloads nil "cedet" "cedet-common/cedet.el")

(defconst cedet-version "1.0pre4" "\
Current version of CEDET.")

;;;***

;;;### (autoloads (define-fame-channel) "fame" "cedet-common/fame.el")

(autoload 'define-fame-channel "fame" "\
Define the new message channel CHANNEL.
CHANNEL must be a non-nil symbol.
The optional argument DEFAULT specifies the default value of message
levels for this channel.  By default it is the value of
`fame-default-level-values'.
DOCSTRING is an optional channel documentation.

This defines the option `CHANNEL-fame-levels' to customize the current
value of message levels.  And the functions `CHANNEL-send-debug',
`CHANNEL-send-info', `CHANNEL-send-warning', and `CHANNEL-send-error',
that respectively send debug, informational, warning, and error
messages to CHANNEL." nil 'macro)

;;;***

;;;### (autoloads (inversion-upgrade-package inversion-add-to-load-path inversion-find-version inversion-require) "inversion" "cedet-common/inversion.el")

(autoload 'inversion-require "inversion" "\
Declare that you need PACKAGE with at least VERSION.
PACKAGE might be found in FILE.  (See `require'.)
Throws an error if VERSION is incompatible with what is installed.
Optional argument DIRECTORY is a location where new versions of
this tool can be located.  If there is a versioning problem and
DIRECTORY is provided, inversion will offer to download the file.
Optional argument RESERVED is saved for later use." nil nil)

(autoload 'inversion-find-version "inversion" "\
Search for the version and incompatible version of PACKAGE.
Does not load PACKAGE nor requires that it has been previously loaded.
Search in the directories in `load-path' for a PACKAGE.el library.
Visit the file found and search for the declarations of variables or
constants `PACKAGE-version' and `PACKAGE-incompatible-version'.  The
value of these variables must be a version string.

Return a pair (VERSION-STRING . INCOMPATIBLE-VERSION-STRING) where
INCOMPATIBLE-VERSION-STRING can be nil.
Return nil when VERSION-STRING was not found." nil nil)

(autoload 'inversion-add-to-load-path "inversion" "\
Add the PACKAGE path to `load-path' if necessary.
MINIMUM is the minimum version requirement of PACKAGE.
Optional argument INSTALLDIR is the base directory where PACKAGE is
installed.  It defaults to `default-directory'/PACKAGE.
SUBDIRS are sub-directories to add to `load-path', following the main
INSTALLDIR path." nil nil)

(autoload 'inversion-upgrade-package "inversion" "\
Try to upgrade PACKAGE in DIRECTORY is available." t nil)

;;;***

;;;### (autoloads nil "mode-local" "cedet-common/mode-local.el")

(defsubst function-overload-p (symbol) "\
Return non-nil if SYMBOL is a function which can be overloaded." (and symbol (symbolp symbol) (get symbol 'mode-local-overload)))

;;;***

;;;### (autoloads (pprint-function pprint pprint-to-string) "pprint" "cedet-common/pprint.el")

(autoload 'pprint-to-string "pprint" "\
Return a string containing the pretty-printed representation of OBJECT.
OBJECT can be any Lisp object.  Quoting characters are used as needed
to make output that `read' can handle, whenever this is possible.  The
pretty printer try as much as possible to limit the length of lines to
given WIDTH.  WIDTH value defaults to `fill-column'." nil nil)

(autoload 'pprint "pprint" "\
Output the pretty-printed representation of OBJECT, any Lisp object.
Quoting characters are printed as needed to make output that `read'
can handle, whenever this is possible.  Output stream is STREAM, or
value of `standard-output' (which see).  The pretty printer try as
much as possible to limit the length of lines to given WIDTH.  WIDTH
value defaults to `fill-column'." nil nil)

(autoload 'pprint-function "pprint" "\
See a pretty-printed representation of FUNCTION-NAME." t nil)

;;;***

(provide 'cedet-common-autoloads)
