;;; DO NOT MODIFY THIS FILE
(if (featurep 'haskell-mode-autoloads) (error "Already loaded"))

;;;### (autoloads nil "_pkg" "haskell-mode/_pkg.el")

(package-provide 'haskell-mode :version 1.11 :author-version "2.1" :type 'regular)

;;;***

;;;### (autoloads (haskell-doc-show-type haskell-doc-mode) "haskell-doc" "haskell-mode/haskell-doc.el")

(autoload 'haskell-doc-mode "haskell-doc" "\
Enter `haskell-doc-mode' for showing fct types in the echo area.
See variable docstring." t nil)

(defalias 'turn-on-haskell-doc-mode 'haskell-doc-mode)

(autoload 'haskell-doc-show-type "haskell-doc" "\
Show the type of the function near point.
For the function under point, show the type in the echo area.
This information is extracted from the `haskell-doc-prelude-types' alist
of prelude functions and their types, or from the local functions in the
current buffer." t nil)

;;;***

;;;### (autoloads (haskell-indent-mode) "haskell-indent" "haskell-mode/haskell-indent.el")

(autoload 'haskell-indent-mode "haskell-indent" "\
``intelligent'' Haskell indentation mode that deals with
the layout rule of Haskell.  \\[haskell-indent-cycle] starts the cycle
which proposes new possibilities as long as the TAB key is pressed.
Any other key or mouse click terminates the cycle and is interpreted
except for RET which merely exits the cycle.
Other special keys are:
    \\[haskell-indent-insert-equal]
      inserts an =
    \\[haskell-indent-insert-guard]
      inserts an |
    \\[haskell-indent-insert-otherwise]
      inserts an | otherwise =
these functions also align the guards and rhs of the current definition
    \\[haskell-indent-insert-where]
      inserts a where keyword
    \\[haskell-indent-align-guards-and-rhs]
      aligns the guards and rhs of the region
    \\[haskell-indent-put-region-in-literate]
      makes the region a piece of literate code in a literate script

Note: \\[indent-region] which applies \\[haskell-indent-cycle] for each line
of the region also works but it stops and asks for any line having more
than one possible indentation.
Use TAB to cycle until the right indentation is found and then RET to go the
next line to indent.

Invokes `haskell-indent-hook' if not nil." t nil)

;;;***

;;;### (autoloads (literate-haskell-mode haskell-mode) "haskell-mode" "haskell-mode/haskell-mode.el")

(autoload 'haskell-mode "haskell-mode" "Major mode for editing Haskell programs.  Last adapted for Haskell 1.4.\nBlank lines separate paragraphs, comments start with `-- '.\n\n\\<haskell-mode-map>\\[indent-for-comment] will place a comment at an appropriate place on the current line.\n\\[comment-region] comments (or with prefix arg, uncomments) each line in the region.\n\nLiterate scripts are supported via `literate-haskell-mode'.  The\nvariable `haskell-literate' indicates the style of the script in the\ncurrent buffer.  See the documentation on this variable for more\ndetails.\n\nModules can hook in via `haskell-mode-hook'.  The following modules\nare supported with an `autoload' command:\n\n   `haskell-decl-scan', Graeme E Moss\n     Scans top-level declarations, and places them in a menu.\n\n   `haskell-doc', Hans-Wolfgang Loidl\n     Echoes types of functions or syntax of keywords when the cursor is idle.\n\n   `haskell-indent', Guy Lapalme\n     Intelligent semi-automatic indentation.\n\n   `haskell-simple-indent', Graeme E Moss and Heribert Schuetz\n     Simple indentation.\n\nModule X is activated using the command `turn-on-X'.  For example,\n`haskell-font-lock' is activated using `turn-on-haskell-font-lock'.\nFor more information on a module, see the help for its `turn-on-X'\nfunction.  Some modules can be deactivated using `turn-off-X'.  (Note\nthat `haskell-doc' is irregular in using `turn-(on/off)-haskell-doc-mode'.)\n\nUse `haskell-version' to find out what version this is.\n\nInvokes `haskell-mode-hook' if not nil." t nil)

(autoload 'literate-haskell-mode "haskell-mode" "As `haskell-mode' but for literate scripts." t nil)
(add-to-list 'auto-mode-alist '("\\.\\(?:[gh]s\\|hi\\)\\'" . haskell-mode))
(add-to-list 'auto-mode-alist '("\\.l[gh]s\\'" . literate-haskell-mode))
(add-hook 'haskell-mode-hook 'turn-on-haskell-doc-mode)
(add-hook 'haskell-mode-hook 'turn-on-haskell-indent)

;;;***

;;;### (autoloads (inferior-haskell-load-file switch-to-haskell) "inf-haskell" "haskell-mode/inf-haskell.el")

(defalias 'run-haskell 'switch-to-haskell)

(autoload 'switch-to-haskell "inf-haskell" "\
Show the inferior-haskell buffer.  Start the process if needed." t nil)

(autoload 'inferior-haskell-load-file "inf-haskell" "\
Pass the current buffer's file to the inferior haskell process." t nil)

;;;***

(provide 'haskell-mode-autoloads)
